// ====================================================================
// Copyright DIGITEO 2009 - Allan CORNET
// ====================================================================
#include <stdlib.h>
#include <sndfile.h>
#include "stack-c.h" 
#include "api_common.h"
#include "api_string.h"
#include "Scierror.h"
#include "localization.h"
#ifdef _MSC_VER
#define strdup _strdup
#endif
/* ==================================================================== */
int sci_sfsupportedformat(char *fname)
{
	char **output = NULL;
	int m_out = 0;
	int n_out = 0;
	
	int count = 0;
	
	CheckLhs(1,1); 
	CheckRhs(0,0); 

	sf_command (NULL, SFC_GET_SIMPLE_FORMAT_COUNT, &count, sizeof (int)) ;

	m_out = count;
	n_out = 1;
  
  output = (char**)malloc(sizeof(char*) * (m_out * n_out));
  if (output)
  {
    int k = 0;
    for (k = 0 ; k < count ; k++)
    {
      SF_FORMAT_INFO  format_info ;
      format_info.format = k ;
      sf_command (NULL, SFC_GET_SIMPLE_FORMAT, &format_info, sizeof (format_info)) ;
      output[k] = strdup(format_info.name);
    }
    
    createMatrixOfString(Rhs + 1, m_out, n_out, output);
    LhsVar(1) = Rhs + 1; 
    C2F(putlhsvar)();
    
		for (k = 0 ; k < count ; k++)
		{
			if (output[k]) {free(output[k]); output[k] = NULL;}
		}
    free(output); output = NULL;
  }
  else
  {
  	Scierror(999, _("%s: No more memory.\n"), fname);
  }
  return 0;
}
/* ==================================================================== */
